package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.MusicPlayerSingleton;
import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Persistence;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.control.Slider;
import javafx.scene.layout.VBox;

import java.net.URL;
import java.util.ResourceBundle;

public class PauseSettingsController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private Slider musicSlider, sfxSlider;
    SceneLoader sceneLoader = new SceneLoader();
    private int musicVolume, sfxVolume;
    MusicPlayerSingleton musicPlayer = MusicPlayerSingleton.getInstance();
    Persistence persistence = Persistence.getInstance();

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        setMusicVolume();
        setSfxVolume();
    }

    @FXML
    private void backButton() {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene("Pause"));
    }

    private void setMusicVolume() {
        musicSlider.setValue(persistence.getSettings().getMusicVolume());
        musicSlider.valueProperty().addListener((observableValue, oldValue, newValue) -> {
            musicVolume = newValue.intValue();
            persistence.getSettings().setMusicVolume(musicVolume);
            musicPlayer.getMediaPlayer().setVolume((double) musicVolume / 100);
        });
    }

    private void setSfxVolume(){
        sfxSlider.setValue(persistence.getSettings().getSfxVolume());
        sfxSlider.valueProperty().addListener(((observableValue, oldValue, newValue) -> {
            sfxVolume = newValue.intValue();
            persistence.getSettings().setSfxVolume(sfxVolume);
//            sfxPlayer.getMediaPlayer().setVolume((double) sfxVolume / 100);
        }));
    }
}
