package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Exceptions.SQLException;

import java.sql.Connection;
import java.util.ArrayList;

public interface ISQLDataBase {

    //Establish Connection
    Connection connect() throws SQLException;

    //CRUD Operations in SQL
    ArrayList<MapData> getCoreMaps() throws SQLException;
    ArrayList<MapInfo> getCommunityMapsList() throws SQLException;
    MapData getCommunityMapByID(String mapID) throws SQLException;
    void uploadCommunityMap(MapData map) throws SQLException;
    void createPlayer(String playerName, String playerPW) throws SQLException;
    String checkCredentials(String playerName) throws SQLException;
    PlayerStatistics getStatistics(String playerName) throws SQLException;
    void updatePlayerStats(PlayerStatistics stats, PlayerAccount account) throws SQLException;
    void resetPlayerStats(PlayerAccount account) throws SQLException;

}
