package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

public class PlayerStatistics {
    private static final Logger log = LogManager.getLogger(PlayerStatistics.class);

    private int gamesLost = 0;
    private int gamesWon = 0;
    private int kills = 0;
    private int deaths = 0;
    private int blocksDestroyed = 0;
    private int gameTime = 0;   //in seconds

    public PlayerStatistics(int gamesLost, int gamesWon, int kills, int deaths, int blocksDestroyed, int gameTime) {
        this.gamesLost = gamesLost;
        this.gamesWon = gamesWon;
        this.kills = kills;
        this.deaths = deaths;
        this.blocksDestroyed = blocksDestroyed;
        this.gameTime = gameTime;
    }


    public int getGamesLost() {
        return gamesLost;
    }

    protected void addGamesLost() {
        gamesLost = gamesLost + 1;
    }

    public int getGamesWon() {
        return gamesWon;
    }

    protected void addGamesWon() {
        gamesWon = gamesWon + 1;
    }

    public int getKills() {
        return kills;
    }

    protected void addKills(int kills) {
        this.kills = this.kills + kills;
    }

    public int getDeaths() {
        return deaths;
    }

    protected void addDeaths(int deaths) {
        this.deaths = this.deaths + deaths;
    }

    public int getBlocksDestroyed() {
        return blocksDestroyed;
    }

    protected void addBlocksDestroyed(int blocksDestroyed) {
        this.blocksDestroyed = this.blocksDestroyed + blocksDestroyed;
    }

    public int getGameTime() {
        return gameTime;
    }

    public int getGameTimeInHours(){
        return gameTime / 3600;
    }

    protected void addGameTime(int gameTime) {
        this.gameTime = this.gameTime + gameTime;
    }

}
