package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadSaveStats extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadSaveStats.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        Threads threadsInstance = Threads.getInstance();

        try {
            threadsInstance.setThreadSaveStatsMsg("");
            threadsInstance.setThreadSaveStats(ThreadStatus.RUNNING);
            persistenceInst.savePlayerStatistics();
            log.info("Save Player-Statistics thread finished successfully!");
            threadsInstance.setThreadSaveStats(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            threadsInstance.setThreadSaveStatsMsg(e.getMessage());
            log.info("Save Player-Statistics thread failed!");
            threadsInstance.setThreadSaveStats(ThreadStatus.FAILED);
        }
    }

}
