package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadStartup1 extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadStartup1.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        Threads threadsInstance = Threads.getInstance();

        try {
            threadsInstance.setThreadStartup1Msg("");
            threadsInstance.setThreadStartup1(ThreadStatus.RUNNING);
            persistenceInst.loadSettings();
            persistenceInst.loadCoreMaps();
            persistenceInst.loadCommunityMaps();
            persistenceInst.verifyAppSettings();
            persistenceInst.verifyCoreMaps();
            persistenceInst.verifyCommunityMaps();
            log.info("Startup routine part1 complete!");
            threadsInstance.setThreadStartup1(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            threadsInstance.setThreadStartup1Msg(e.getMessage());
            log.info("Startup routine part1 failed!");
            threadsInstance.setThreadStartup1(ThreadStatus.FAILED);
        }
    }

}
