package de.hdm_stuttgart.battlearena.Model.Sound;

import de.hdm_stuttgart.battlearena.Controller.GameSceneController;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.AppSettings;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Persistence;
import de.hdm_stuttgart.battlearena.Model.Entity.IEntity;
import de.hdm_stuttgart.battlearena.Model.Inputs.InputHandler;
import de.hdm_stuttgart.battlearena.Model.Map.ITile;
import de.hdm_stuttgart.battlearena.Model.Map.TileManager;

import javafx.scene.media.AudioClip;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;


public class SoundEffects {
    private static final Logger log = LogManager.getLogger(SoundEffects.class);
    private static final SoundEffects sfx = new SoundEffects();

    public SoundEffects(){};

    SoundFileManager fileManager = new SoundFileManager();
    private AppSettings settings = Persistence.getInstance().getSettings();


    public void playSoundEffect(GameSceneController gameSceneController, InputHandler inputHandler) throws IOException, InterruptedException {
        log.info(inputHandler);
        TileManager tileManager = gameSceneController.getTileManager();
        log.info(tileManager);
        IEntity player = gameSceneController.getPlayer();
        ITile[] tileSet = tileManager.getTileSet();
        int[][] map = tileManager.getTileMap();
        int playerPosX;
        int playerPosY;
        int mapTile;


        System.out.println(inputHandler.isMoveUp());
        while(inputHandler.isMoveDown() || inputHandler.isMoveUp() || inputHandler.isMoveLeft() || inputHandler.isMoveRight()){
            playerPosX = player.getMapPosX();
            playerPosY = player.getMapPosY();
            mapTile = map[playerPosY/48][playerPosX/48]; //TODO FIND ANOTHER WAY to get to the map tile
            System.out.println(mapTile);
            SFXLoop sfx = tileSet[mapTile].getSoundeffect();
            System.out.println(playerPosX);
           if(!(sfx == SFXLoop.NONE)) {
                Path path = Paths.get(sfx.getPath());
                List<Path> sfxPaths = fileManager.getFilePathsFromResources(path);
                String randomPath = fileManager.getRandomFilePath(sfxPaths);
                String resource = fileManager.convertPathToResourcePath(randomPath);
                Thread sfxLoop = new Thread(() -> {
                    AudioClip effect = new AudioClip(getClass().getResource(resource).toString());
                    effect.setVolume((double) Persistence.getInstance().getSettings().getSfxVolume() /100);
                    effect.play();
                });
                sfxLoop.setDaemon(true);
                sfxLoop.start();
                sfxLoop.sleep(300);
                sfxPaths.clear();
            }
        }


            System.out.println("hallo");


    }


    public void playSoundEffectOnce(SFX soundEffect){
        String path = soundEffect.getPath();
        String resource = path.substring(18); // Begins at Ressource Folder
        Thread sfx = new Thread(()->{
            AudioClip audioClip = new AudioClip(getClass().getResource(resource).toExternalForm());
            audioClip.play();
            audioClip.setVolume((double) Persistence.getInstance().getSettings().getSfxVolume() /100);
        });
        sfx.setDaemon(true);
        sfx.start();


    }


    public void setSfxVolume(int volume){
        Persistence.getInstance().getSettings().setSfxVolume(volume);
        //Set Volume for One Time sound effects and Loops
    }

    public int getVolume(){
        return Persistence.getInstance().getSettings().getMusicVolume();
    }

    public SoundEffects getInstance(){return sfx;}

}
